# -*- coding: utf-8 -*-
# Generated by Django 1.11.5 on 2017-09-15 14:20
from __future__ import unicode_literals

from django.db import migrations
from itertools import chain

def source_vcenters_from_selves(apps, schema_editor):    
    # Where we have statements that (probably) came from the vcenter
    # importer, adjust their sources to match so that the new source-aware
    # vcenter importer overwrites them correctly.
    #
    # Note that this doesn't do a perfect job: its aim is to leave the number
    # of anomalies small enough to correct by hand.
    vcenter_predicates = ('label',
                          'vmware-instance-uuid',
                          'vmware-mo-ref',
                          'vmware-notes',
                          'vmware-guest-full-name',
                          'vmware-user',
                          'mac-address',
                          'console')
    Resource = apps.get_model("ucs_besplusplus", "Resource")
    for vm in Resource.objects.filter(properties_fwd__predicate_id="type",
            properties_fwd__object_res_id="vmware-vm"):
        consoles = vm.properties_fwd.filter(predicate_id='console')
        if len(consoles) == 0: continue
        vcenter = consoles[0].object_res
        for p in chain(
                vm.properties_fwd.filter(predicate_id__in=vcenter_predicates),
                vm.properties_fwd.filter(predicate_id='type',
                                          object_res_id='vmware-vm'),
                vm.properties_rev.filter(predicate_id='hosts-vm')):
            p.source = vcenter
            p.save()

class Migration(migrations.Migration):

    dependencies = [
        ('ucs_besplusplus', '0006_fqdn_alias'),
    ]

    operations = [
        migrations.RunPython(source_vcenters_from_selves,
                             migrations.RunPython.noop),
    ]
